// MultiFileUploader
//
// Release 1.00 (Jan 22, 2012)
//
// Copyright (c) 2012 Yujiro Araki
//
// licence: limit 20 MT Install.

var files = new Array();

var PageState = {
    SELECT: 0,
    UPLOADING: 1
};

var updatePage = function(mode){
    switch(mode){
        case PageState.SELECT:
            jQuery("#uploadStatePnl").hide();
            jQuery("#preview").empty();
            break;
        case PageState.UPLOADING:
            jQuery("#filePreviewPnl").hide();
            jQuery("#uploadStatePnl").show();
            updateProgress(0);
            break;
    }
}

var updateProgress = function(value){
    jQuery("#progressbar").progressbar("value", value);
}

var upload = function() {
    var targets = files;
    if (targets.length == 0) {
        return;
    }
    if (site_path == 2) {
        alert('アップロード先を選択してください');
        return;
    }
    jQuery("#filearea").slideUp();
    jQuery("#filedrag").hide();
    jQuery("#submitbutton").css('display','none');
    jQuery("#cancelbutton").css('display','none');

    var total = targets.length;
    var done = 0;
    var beginTime;
    var isAbort = false;
    var incr = function(){
        ++done;
    };

    var updateStatus = function(){
        updateProgress(done / total * 100);

        var exec_file = '';
        if (done != total) {
            exec_file = files[done].name;
            jQuery("#progressmsg").text(exec_file + " アップロード中...（" + done + " / " + total + "完了）");
        } else {
            jQuery("#progressmsg").text(" アップロード完了（" + done + " / " + total + "）");
            _isUploading = false;
            var endTime = (new Date()).getTime();
            var uploadSec = (endTime - beginTime) / 1000;
            jQuery('#start_message').css('visibility', 'hidden');
//            alert("完了しました。（" + uploadSec + "秒）");
//            alert("完了しました。");
            jQuery('#end_message').css('display', 'block');

//            updatePage(PageState.SELECT);
//            jQuery('#start_message').css('visibility', 'visible');
        }
    };

    var abort = function(){
        isAbort = true;
        updatePage(PageState.SELECT);
        _isUploading = false;
        alert("中止しました。");
    };

    var startThread = function(files){
        var i = 0;
        var len = files.length;
        var retry = 0;
        var iter = function(){
            if (i < len) {
                var file = files[i++];
                var fd = new FormData();
                fd.append("file", file);
                fd.append("blog_id", blog_id);
                fd.append("__mode", 'multi_file_upload');
                fd.append("site_path", site_path);
                fd.append("middle_path", middle_path);
                fd.append("extra_path", extra_path);
                fd.append("has_overwrite", has_overwrite);
                fd.append("tags", tags); 
                fd.append("entry_id", entry_id);
                fd.append("entry_id2", entry_id2);
                jQuery.ajax({
                    url: script_url,
                    type: "POST",
                    data: fd,
                    processData: false,
                    contentType: false,
                    success: function() {
                        if (isAbort) {
                            return;
                        }
                        incr();
                        updateStatus();
                        retry = 0;
                        iter();
                    },
                    error: function(xhr, textStatus, errorThrown) {
                        if (isAbort) {
                            return;
                        }
                        console.log(xhr);
                        console.log(textStatus + ": " + errorThrown);

                        if (xhr.status == 500 && retry < 3) {
                            console.log("retry: " + file.name);

                            i--;
                            retry++;
                            iter();
                        } else {

                            // 同ファイルで3回リトライしても失敗した場合は終了
                            alert("「" + file.name + "」はエラーが発生したためアップロードできませんでした。");

                            if(confirm("残りのファイルのアップロード処理を続けますか？")){
                                iter();
                            } else {
                                // 中止
                                abort();
                            }
                        }
                    }
                });
            } else {

                // complete
                incr();
                updateStatus();
            }
        };
        iter();
    };

    // スレッドに配布するファイルリストを作成
    var tnum = 1; //jQuery("#threadnum").val(), 
    var tpool = [];
    for (var i = 0; i < tnum; ++i) {
        tpool.push([]);
    }
    for (var i = 0; i < total; ++i) {
        tpool[i % tnum].push(targets[i]);
    }

    // 状態を初期化した後に各スレッドを開始
    updateStatus();
    updatePage(PageState.UPLOADING);
    beginTime = (new Date()).getTime();
    _isUploading = true;

    jQuery("#progressbar").progressbar();

    for (var i = 0; i < tnum; ++i) {
        startThread(tpool[i]);
    }
}

// output information
var output = function(msg) {
    jQuery("#messages").append(msg);
}

// file drag hover
var fileDragHover = function(e) {
    e.stopPropagation();
    e.preventDefault();
    e.target.className = (e.type == "dragover" ? "hover" : "");
}

// file selection
var fileSelectHandler = function(e) {

    // cancel event and hover styling
    fileDragHover(e);

    // fetch FileList object
    var tmp = new Array();
    tmp = e.target.files || e.dataTransfer.files;
    var flag = 0;
    for (var i = 0; i < tmp.length; i++) {
        for (var j = 0; j < files.length; j++) {
            if (tmp[i].name == files[j].name) {
                flag = 1;
            }
        }
        if (!flag) {
           files[files.length] = tmp[i];
        }
    }

    // process all File objects
    jQuery("#messages").html('');

    for (var i = 0, f; f = files[i]; i++) {
        parseFile(f, i);
    }
}

// output file information
var parseFile = function(file, i) {
    output(
        '<p><span id="thumbnail' + i + '"></span> ' + file.name + " 形式：" + file.type + " サイズ：" + file.size + 'バイト <a href="#" data="' + file.name + '" class="delete" >削除</a></p>'
    );
//    createIcon(file, i);
}

var cancel_upload = function() {
    files = [];
    jQuery("#messages").html('<p>アップロードファイルの一覧をここに表示します</p>');
    jQuery('#wrap').html('<input type="file" id="file" name="file" multiple="multiple" />');
}

jQuery(function() {
    jQuery.event.props.push('dataTransfer');

    // initialize
    jQuery('#filedrag').show();

    jQuery('#uploadStatePnl').hide();

    // file select
    jQuery('#file').live("change", function(e) {
        fileSelectHandler(e);
    });

    jQuery('#filedrag').live('dragover', function(e) {
        fileDragHover(e);
    });

    jQuery('#filedrag').live('dragleave', function(e) {
        fileDragHover(e);
    });

    jQuery('#filedrag').live('drop', function(e) {
        fileSelectHandler(e);
    });

    jQuery('#continue').click(function() {
        updatePage(PageState.SELECT);
        jQuery('#start_message').css('visibility', 'visible');
        jQuery('#end_message').css('display', 'none');

        // fileの内容をクリア
        files = [];
        jQuery("#filearea").show();
        jQuery("#filedrag").show();
        jQuery("#submitbutton").css('display','inline');
        jQuery("#cancelbutton").css('display','inline');
        jQuery("#messages").html('<p>アップロードファイルの一覧をここに表示します</p>');
        jQuery('#wrap').html('<input type="file" id="file" name="file" multiple="multiple" />');
        jQuery('#wrap2').html('<input type="text" id="tags" name="tags" />'); 
        return false;
    });


    jQuery('#submitbutton').live('click', function() {
        // middle_path is setted.
        if (!middle_path) {
            middle_path = '';
        }
        site_path = jQuery('#site_path option:selected').val();
        extra_path = jQuery('#extra_path').val();
        has_overwrite = jQuery('#has_overwrite option:selected').val();
        tags = jQuery('#tags').val(); 
        entry_id = jQuery('#entry_id option:selected').val();
        entry_id2 = jQuery('#entry_id2').val();
        upload();
    });

    jQuery('#cancelbutton').live('click', function() {
        cancel_upload();
    });

    jQuery('.delete').live('click', function() {
        var delete_filename = jQuery(this).attr('data');
        for (var i = 0; i < files.length; i++) {
            if (delete_filename == files[i].name) {
                files.splice(i, 1);
            }
        }
        if (files.length == 0) {
            jQuery("#messages").html('アップロードファイルの一覧をここに表示します');
        } else {
            jQuery("#messages").html('');
            for (var i = 0, f; f = files[i]; i++) {
                parseFile(f, i);
            }
        }
        return false;
    });

});

var textIcon = static_url + "plugins/MultiFileUploader/images/file.gif";
var imageIcon = static_url + "plugins/MultiFileUploader/images/image.gif";
var audioIcon = static_url + "plugins/MultiFileUploader/images/audio.gif";
var movieIcon = static_url + "plugins/MultiFileUploader/images/video.gif";
var unknownIcon = static_url + "plugins/MultiFileUploader/images/unknown.png";

var createIcon = function(file, i){

    var imgpnl = document.createElement("div");
    imgpnl.className = "imgpnl";
    jQuery('#thumbnail' + i).append(imgpnl);

    var img = new Image();
    imgpnl.appendChild(img);
    imgpnl.setAttribute('style', 'display: inline');

    var fileType = getFileType(file);
    switch(fileType){
        case "text":
            img.src = textIcon;
            break;
        case "audio":
            img.src = audioIcon;
            break;
        case "movie":
            img.src = movieIcon;
            break;
        case "image":
            img.src = imageIcon;
            try {
                readFile(file, img, i);
            } catch(e) {
                img.src = unknownIcon;
            }
            return;
        default:
            img.src = unknownIcon;
            break;
    }
};

var readFile = function(file, img, i){
    var reader = new FileReader();

    reader.onload = function(){
        jQuery('<img>').attr({
            src: reader.result
        }).load(function () {
            var image = jQuery(this);
            var height = image.height();
            var width  = image.width();
            var css = { position: 'absolute' };
            if (height > width) {
                height *= 30 / width;
                width = 30;
            } else {
                width *= 30 / height;
                height = 30;
            }
            jQuery('#thumbnail' + i).html(
                jQuery('<img>').attr({
                    src: reader.result,
                    height: height,
                    width: width,
                    style: 'border:1px solid #999;vertical-align: middle',
                })
            );
        });
    };
    reader.readAsDataURL(file);
};

var getFileType = function(file){
    var imageType = /image.*/,
        videoType = /video.*/,
        audioType = /audio/,
        textType = /text.*/;

    if(file.type.match(imageType)){
        return "image";
    }
    else if(file.type.match(videoType)){
        return "video";
    }
    else if(file.type.match(audioType)){
        return "audio";
    }
    else if(file.type.match(textType)){
        return "text";
    }
    return null;
};

var jump = function(url) {
    location.href = url;
}
